# Package Managers in embedded linux

## Embedded or non-embedded?

* It is hard to make categorize
* Package managers used commonly today selected
* Principle is always the same:
    * Setup installation feeds
    * Install, remove, update, list
* Selected: APT, OPKG, SMART

## Advanced Packaging Tool (APT)
\subsection{APT}
* Popular in Debian, Ubuntu and related
* Configuration in /etc/apt
* Feeds in /etc/apt/sources.list and/or in  /etc/apt/sources.list.d/ folder
* A lot of packages available

## APT - feeds/repositories
* Contain .deb files called packages
* URLs listed in format: "deb <url> <distribution>" (e.g.: deb http://deb.debian.org/debian buster) 
* Possible to install from file: apt install ./mypackage.deb
* Every package:
    * Contains pre/post install and pre/post remove scripts
    * Names of dependencies/prerequisites
    * Version, maintainer, etc.

## APT - operations
* apt install <package name> : installation
* apt purge <package name>   : uninstall and remove
* apt search <package name>  : search for package
* apt list <package name>    : list installed packages
* apt update                 : get updated list of available packages
* <package name> can be a wildcard


## APT - example package inside
![](img/debpackage.png){width=400px}
* dpkg-buildpackage  command used to create .deb


## Open Package Management (OPKG)
\subsection{OPKG}
* Used in OpenWRT, Buildroot and Yocto 
* Simpler than APT, however less packages available
* Fork and successor of IPKG (dead/dying)
* Command line interface *very* similar to APT
* Uses .ipk packages

## OPKG - feeds
```
root@Omega-1773:~# ls /etc/opkg
customfeeds.conf    distfeeds.conf
root@Omega-1773:~# cat /etc/opkg/customfeeds.conf 
# add your custom package feeds here
#
# src/gz someName http://www.example.com/path/
```

## OPKG - package structure
```
packages/serialnumber/
|-- ipkbuild
|   `-- example_package
|       |-- control.tar.gz 
|       |   |-- control   - prerequisites, maintainer name,...
|       |   |-- postinst  - run after installation
|       |   |-- preinst   - run before installation
|       |   `-- prerm     - run before removal
|       |-- data.tar.gz   - actual package files
|       |   |-- usr
|       |   |   `-- bin
|       |   |       `-- my_binary
|       `-- debian-binary - version of the packaging used
`-- example_package_1.3.3.7_varam335x.ipk
```


## SMART
\subsection{SMART}
* Modern, version 1.0 in 2008
* Merged in Yocto project
* Supports RPM, APT, Slackwate "channels"
* Has a command line GUI interface
* Future of packaging in Linux world?
* Link: <https://labix.org/smart>


