\subsection{Example 4 - GPIO On RedPitaya}
## Example 4 - GPIO on RedPitaya

> Update the existing GPIO controller driver so it supports
> "default-on" property.

1. Inspect the device tree used on the running board
2. Check the module hierarchy to handle onboard LEDs
3. Add a `default-on` property to GPIO controller node.
   The property is an array of
   pin numbers that will become "ON" after driver startup.
   Use pins of user LED 3 and 4.
3. Update the driver of used GPIO controller so that
  it loads the array of pins from the DeviceTree and
  sets them to log. "1"
4. Rebuild the kernel and replace the default kernel on
  RedPitaya
5. Boot the board with new kernel

## Example 4 - Inspecting the onboard devtree

* The device tree blob is stored in `/boot/devicetree.dtb` on the target
* Copy the blob to `src/04_gpio_zynq` folder
* Convert the blob to source and inspect in text editor
  ```sh
  dtc -I dtb -O dts <source> -o <output>
  ```
* Find out the compatible string of GPIO controller
* Find the GPIO controller driver within the Linux kernel tree
  ```sh
  cd src/linux-xlnx
  grep -Hnr --color "the_compatible_string" *
  ```

## Example 4 - Making changes

* Add the `default-on` property to the GPIO controller node,
  containing numbers of pins used for user LED3 and LED4
* Modify the `probe` function of the GPIO controller driver
  so it:
  * loads an array of integers from `default-on` property
  * sets appropriate pin directions to "OUT"
  * sets appropriate pin states to "1"

## Example 4 - Build and load

![](img/docker_logo.png){width=50px}

* Build the device tree
* Rebuild the kernel with updated module

![](img/pitaya_logo.png){width=50px}

* Remount the `/boot` partition as RW
* Replace the `uImage` and `devicetree.dtb`
